/*****************************
* Source : xuguk.prg           
* System : <unkown>           
* Author : Phil Ide           
* Created: 04/02/2003             
*                             
* Purpose:                    
* ----------------------------
* History:                    
* ----------------------------
*    04/02/2003 14:47 PPI - Created                
*****************************/
                              
#include "xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "simpleio.ch"

#define CRLF Chr(13)+Chr(10)

proc appsys(); return
proc dbesys(); return

proc main(cQueryFile, dbName, user, pwd)
   local r, c, c1 := 0, x
   local cConnect
   local oPG
   local cSQL
   local oRes
   local aF
   local i, n
   local aFNames
   local nH
   local oHRTimer := HRTimer():new()

   default cQueryFile to 'query0.sql'

   cConnect := "host=localhost dbname="+dbName+" user="+user+" password="+pwd
   oPG := PGSql():new()
   if FExists(cQueryFile) .and. oPG:connect( cConnect )
      cSQL := LoadQuery(cQueryFile)
      oHRTimer:start()
      if oPG:exec(cSQL)
         oHRTimer:stop()
         oRes := oPG:result

         msgBox("Done!"+CRLF+;
                "rows="+LTrim(Str(oRes:rows))+CRLF+;
                "Time="+LTrim(Str(oHRTimer:duration,15,12))+" secs","SQL Test")


         // uncomment this block to test using dynamic column names
         // you'll also need to change the column names used (_header, _name) to
         // whatever is suitable for your query.
         //
         /*
         aFNames := oRes:getFieldnames()

         // the lazy way...
         //
         nH := FCreate('result1.txt')
         while !oRes:eof()
            cLine := ''
            for i := 1 to Len(aFNames)
               cLine += oRes:&(aFNames[i])+'  '
            next
            FWrite( nH, cLine+CRLF )
            oRes:skip() // could be oRes:skip(-1)
         enddo
         FClose(nH)

         oRes:goTop() // go top!

         // the hard way...using dynamic column names
         //
         nH := FCreate('result2.txt')
         while !oRes:eof()
            cLine := oRes:_header+'  ' // field names are NOT case-sensitive!
            cLine += oRes:_name+CRLF
            FWrite( nH, cLine )
            oRes:skip()
         enddo
         FClose(nH)

         nH := FCreate('result3.txt') // now produce results in reverse order
         while !oRes:bof()
            cLine := ''
            for i := 1 to Len(aFNames)
               cLine += oRes:&(aFNames[i])+'  '
            next
            FWrite( nH, cLine+CRLF )
            oRes:skip(-1)
         enddo
         FClose(nH)
         */
         Browse(oRes)

         oRes:destroy()
      endif
      oPG:disconnect()
   endif
   return

FUNCTION GuiStdDialog( cTitle )
      LOCAL oDlg
      local aSize := AppDeskTop():currentSize()
      local aPos  := AppDeskTop():currentSize()

      aSize[1] *= 0.90
      aSize[2] *= 0.75

      aPos[1] := (aPos[1] - aSize[1])/2
      aPos[2] := (aPos[2] - aSize[2])/2
    
      DEFAULT cTitle TO "Standard Dialog Window" 

      oDlg          := XbpDialog():new( ,,aPos, aSize,, .F. )
      oDlg:icon     := 1 
      oDlg:taskList := .T. 
      oDlg:title    := cTitle 
      oDlg:create() 
      oDlg:drawingArea:setFontCompoundName( "8.Helv" ) 
 

   RETURN oDlg 

Function Browse(oPGResult)
   local oDlg := GuiStdDialog("SQL Browse")
   local oBr := myPGSQLBrowse():new(oDlg:drawingArea):create()
   local i
   local cField

   local nEvent
   local mp1
   local mp2
   local oXbp

   oBr:setup(oPGResult)

   altd()

   for i := 1 to oPGResult:cols
      cField := oPGResult:fname(i-1)
      oBr:addColumn( MakeFieldBlock( oPGResult, cField ), , cField )
   next

   oDlg:drawingArea:resize := {|mp1,mp2,obj| obj:childlist()[1]:setSize(mp2) }
   oDlg:show()
   oBr:show()
   SetAppFocus(oBr)
   While nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
   Enddo
   oDlg:destroy()
   return Nil

Function MakeFieldBlock( o, c )
   return {|| o:&(c) }


Function LoadQuery(cFile)
   local cData := MemoRead(cFile)
   local cComment
   local nStart, nEnd

   if (nStart := At('/*',cData)) > 0
      if (nEnd := At('*/',cData,nStart+2)) > 0
         cComment := AllTrim(SubStr( cData, nStart+2, nEnd-(nStart+3) ))
         if !Empty(cComment)
            msgBox(cComment,"Query Comment - "+cFile)
         endif
      endif
   endif
   return cData

